# 事業を支えるPHP 第8回 サンプルコード

## 注意事項

　このサンプルコードにはデータベースの環境のセットアップはありません。自分で用意する必要があります。

## コードを動かすために必要なデータ
　都道府県テーブル、地方テーブルのデータは下記記事を参考にさせていただきました。
　https://qiita.com/chiyoyo/items/51891a8956e03422dc88#%E3%83%86%E3%83%BC%E3%83%96%E3%83%AB%E4%BD%9C%E6%88%90-1
　
　userテーブルは以下の定義です
  ```sql
  CREATE TABLE `user` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
    `name` varchar(255) DEFAULT NULL,
    `name_kana` varchar(255) DEFAULT NULL,
    `created_at` datetime DEFAULT NULL,
    `updated_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
  )
  ```

## ライブラリのインストール

　`make install` で依存ライブラリのセットアップが行われます。詳しくはMakefileを読んでください。

## サンプルコードファイル

 各ファイルに用意されているサンプルコードの内容は以下のとおりです。

* PDO
  * pdo1.php
    * PDOでエラー時は例外を投げる設定
  * pdo2.php
    * bindValueを必ず使う
* クエリビルダ(Aura\SqlQuery)
  * querybuilder.php
    * 条件句を組み立てたい場合はクエリビルダを検討する
* Doctrine DBAL
  * dbal.php
    * IN句を指定できるDoctrine DBAL
* Eloquent
  * eloquent1.php
    * モデルの定義
    * 事前準備
    * 発行されたSQLの確認
    * 使い方
    * N+1対応
  * eloquent2.php
    * クエリビルダ
* Doctrine
  * doctrine1.php
    * Entityの定義
	* 事前準備
	* 発行されたSQLの確認
	* 使い方
	* N+1対応 (DQL)
  * doctrine2.php
    * N+1対応を アノテーションで行う例

## License

MIT
