<?php
/**
 * bindValueを必ず使う
 */
$dsn = 'mysql:dbname=demo;host=127.0.0.1';
$user = 'demo';
$password = 'demo';

try {
    $dbh = new PDO($dsn, $user, $password);
    $dbh->setAttribute(PDO::ATTR_ERRMODE, 
	                   PDO::ERRMODE_EXCEPTION);
} catch (PDOException $e) {
    echo 'Error!';
    exit;
}

$regionId = 6;
$name = '';

// Nowdocで変数が展開されないように工夫
$sql = <<<'SQL'
 SELECT id, name 
FROM prefecture 
WHERE region_id =:region_id 
AND name LIKE :name
ORDER BY id
SQL;

$sth = $dbh->prepare($sql);
$sth->bindValue(':region_id', $regionId, 
                 PDO::PARAM_INT);
$sth->bindValue(':name', '%' . $name . '%', 
                 PDO::PARAM_STR);
$sth->execute();
echo $sth->debugDumpParams();
// Sent SQL: [84] SELECT id, name FROM prefecture 
// WHERE region_id =6 AND name LIKE '%山%' ORDER BY id
print_r($sth->fetchAll());